'//+--------------------------------------------------------------------------+
'//|                                                                          |
'//|                                 HUD Movie                                |
'//|                                                                          |
'//|                HUD composited window for VISTA and SEVEN.                |
'//|                    Based on direct use of the core API.                  |
'//|                  Theme by WinLIFT and graphic by GDImage.                |
'//|                                                                          |
'//|                               Version 1.00Ab                             |
'//|                                                                          |
'//+--------------------------------------------------------------------------+
'//|                                                                          |
'//|                         Author Patrice TERRIER                           |
'//|            8 Domaine de Rochagnon. 38800 Champagnier  FRANCE             |
'//|                       http://www.zapsolution.com                         |
'//|                    E-mail: pterrier@zapsolution.com                      |
'//|                                                                          |
'//|                   copyright (c) 2010 Patrice TERRIER                     |
'//|                                                                          |
'//+--------------------------------------------------------------------------+
'//|                  Project started on : 04-18-2010                         |
'//|                        Last revised : 04-26-2010                         |
'//+--------------------------------------------------------------------------+

#COMPILE EXE "HUDmovie.exe"

DECLARE FUNCTION zTrace LIB "zTrace.DLL" ALIAS "zTrace" (zMessage AS ASCIIZ) AS LONG

%WINAPI                                         = 1
%HWND_TOPMOST                                   = &HFFFFFFFF???
%HWND_NOTOPMOST                                 = &HFFFFFFFE???
%WM_IME_NOTIFY                                  = &H0282
%WM_CLOSE                                       = &H10
%SWP_SHOWWINDOW                                 = &H0040
%MAX_PATH                                       = 260
%CB_ADDSTRING                                   = &H143
%CB_RESETCONTENT                                = &H14B
%CB_GETCURSEL                                   = &H147
%CB_GETLBTEXT                                   = &H148
%CB_SETCURSEL                                   = &H14E
%CBN_SELENDOK                                   = 9
%TRUE                                           = 1
%FALSE                                          = 0
%NULL                                           = 0
%WM_USER                                        = &H400
%ERROR_ALREADY_EXISTS                           = 183
%NM_FIRST                                       = 0
%NM_MOVIEPLAYING                                = %NM_FIRST - 81
%SW_HIDE                                        = 0
%SW_SHOW                                        = 5
%SW_RESTORE                                     = 9
%WM_DESTROY                                     = &H2
%WM_MOVE                                        = &H3
%WM_SIZE                                        = &H5
%WM_SETTEXT                                     = &HC
%WM_NOTIFY                                      = &H4E
%WM_WINDOWPOSCHANGED                            = &H47
%WM_COMMAND                                     = &H111
%WM_VSCROLL                                     = &H115
%WS_POPUP                                       = &H80000000
%WS_CHILD                                       = &H40000000
%WS_VISIBLE                                     = &H10000000
%WS_CLIPSIBLINGS                                = &H04000000
%WS_CLIPCHILDREN                                = &H02000000
%WS_CAPTION                                     = &H00C00000  ' WS_BORDER OR WS_DLGFRAME
%WS_SYSMENU                                     = &H00080000
%WS_THICKFRAME                                  = &H00040000
%WS_TABSTOP                                     = &H00010000
%WS_MINIMIZEBOX                                 = &H00020000
%WS_MAXIMIZEBOX                                 = &H00010000
%CS_VREDRAW                                     = &H1
%CS_HREDRAW                                     = &H2
%PM_REMOVE                                      = &H0001
%SW_SHOWNOACTIVATE                              = 4
%SWP_NOSIZE                                     = &H0001
%SWP_NOMOVE                                     = &H0002
%SWP_NOACTIVATE                                 = &H0010
%SWP_NOOWNERZORDER                              = &H0200  ' Don't do owner Z ordering
%SM_CXSCREEN                                    = 0
%SM_CYSCREEN                                    = 1
%RDW_INVALIDATE                                 = &H1
%RDW_INTERNALPAINT                              = &H2
%RDW_ERASE                                      = &H4
%RDW_ALLCHILDREN                                = &H80
%RDW_UPDATENOW                                  = &H100
%RDW_ERASENOW                                   = &H200
%RDW_FRAME                                      = &H400
%IDC_ARROW                                      = 32512&
%BS_AUTOCHECKBOX                                = &H3&
%BS_AUTORADIOBUTTON                             = &H9&
%BST_UNCHECKED                                  = &H00
%BST_CHECKED                                    = &H01
%BM_GETCHECK                                    = &HF0
%BM_SETCHECK                                    = &HF1
%LBS_HASSTRINGS                                 = &H40&
%TBS_AUTOTICKS                                  = &H0001
%TBS_VERT                                       = &H0002
%TBS_BOTTOM                                     = &H0000
%TBM_GETPOS                                     = %WM_USER
%TBM_SETPOS                                     = %WM_USER + 5
%TBM_SETRANGE                                   = %WM_USER + 6
%TBM_SETTICFREQ                                 = %WM_USER + 20
%TBM_SETPAGESIZE                                = %WM_USER + 21
%TBM_SETLINESIZE                                = %WM_USER + 23

%CBS_AUTOHSCROLL       = &H40&
%CBS_DROPDOWNLIST      = &H3&
%WS_VSCROLL            = &H00200000
%CBS_HASSTRINGS        = &H200&

TYPE RECT
  nLeft AS LONG
  nTop AS LONG
  nRight AS LONG
  nBottom AS LONG
END TYPE

TYPE POINTAPI
  x AS LONG
  y AS LONG
END TYPE

TYPE POINTS
  x AS INTEGER
  y AS INTEGER
END TYPE

TYPE tagMSG
  hwnd AS DWORD
  message AS DWORD
  wParam AS LONG
  lParam AS LONG
  time AS DWORD
  pt AS POINTAPI
END TYPE

TYPE SECURITY_ATTRIBUTES
  nLength AS DWORD
  lpSecurityDescriptor AS LONG
  bInheritHandle AS LONG
END TYPE

TYPE WNDCLASSEX
    cbSize AS DWORD
    STYLE AS DWORD
    lpfnWndProc AS LONG
    cbClsExtra AS LONG
    cbWndExtra AS LONG
    hInstance AS DWORD
    hIcon AS DWORD
    hCursor AS DWORD
    hbrBackground AS DWORD
    lpszMenuName AS ASCIIZ PTR
    lpszClassName AS ASCIIZ PTR
    hIconSm AS DWORD
END TYPE

TYPE BITMAP
  bmType AS LONG
  bmWidth AS LONG
  bmHeight AS LONG
  bmWidthBytes AS LONG
  bmPlanes AS WORD
  bmBitsPixel AS WORD
  bmBits AS BYTE PTR
END TYPE

TYPE NMHDR
  hwndFrom AS DWORD
  idfrom AS DWORD
  code AS LONG    ' used for messages, so needs to be LONG, not DWORD...
END TYPE

DECLARE FUNCTION CloseHandle LIB "KERNEL32.DLL" ALIAS "CloseHandle" (BYVAL hObject AS DWORD) AS LONG
DECLARE FUNCTION CreateMutex LIB "KERNEL32.DLL" ALIAS "CreateMutexA" (lpMutexAttributes AS SECURITY_ATTRIBUTES, BYVAL bInitialOwner AS LONG, lpName AS ASCIIZ) AS LONG
DECLARE FUNCTION CreateWindowEx LIB "USER32.DLL" ALIAS "CreateWindowExA" (BYVAL dwExStyle AS DWORD, lpClassName AS ASCIIZ, lpWindowName AS ASCIIZ, BYVAL dwStyle AS DWORD, BYVAL x AS LONG, BYVAL y AS LONG, _
    BYVAL nWidth AS LONG, BYVAL nHeight AS LONG, BYVAL hWndParent AS DWORD, BYVAL hMenu AS DWORD, BYVAL hInstance AS DWORD, lpParam AS ANY) AS DWORD
DECLARE FUNCTION DefWindowProc LIB "USER32.DLL" ALIAS "DefWindowProcA" (BYVAL hWnd AS DWORD, BYVAL uMsg AS DWORD, BYVAL wParam AS DWORD, BYVAL lParam AS LONG) AS LONG
DECLARE FUNCTION DispatchMessage LIB "USER32.DLL" ALIAS "DispatchMessageA" (lpMsg AS tagMSG) AS LONG
DECLARE FUNCTION FindWindow LIB "USER32.DLL" ALIAS "FindWindowA" (lpClassName AS ASCIIZ, lpWindowName AS ASCIIZ) AS LONG
DECLARE FUNCTION GetClassInfoEx LIB "USER32.DLL" ALIAS "GetClassInfoExA" (BYVAL hInst AS DWORD, lpszClass AS ASCIIZ, lpWndClass AS WNDCLASSEX) AS LONG
DECLARE FUNCTION GetClientRect LIB "USER32.DLL" ALIAS "GetClientRect" (BYVAL hwnd AS DWORD, lpRect AS RECT) AS LONG
DECLARE FUNCTION GetDlgCtrlID LIB "USER32.DLL" ALIAS "GetDlgCtrlID" (BYVAL hWnd AS DWORD) AS LONG
DECLARE FUNCTION GetDlgItem LIB "USER32.DLL" ALIAS "GetDlgItem" (BYVAL hDlg AS DWORD, BYVAL nIDDlgItem AS LONG) AS DWORD
DECLARE FUNCTION GetLastError LIB "KERNEL32.DLL" ALIAS "GetLastError" () AS LONG
DECLARE FUNCTION GetMessage LIB "USER32.DLL" ALIAS "GetMessageA" (lpMsg AS tagMSG, BYVAL hWnd AS DWORD, BYVAL uMsgFilterMin AS DWORD, BYVAL uMsgFilterMax AS DWORD) AS LONG
DECLARE FUNCTION GetSystemMetrics LIB "USER32.DLL" ALIAS "GetSystemMetrics" (BYVAL nIndex AS LONG) AS LONG
DECLARE FUNCTION GetWindow LIB "USER32.DLL" ALIAS "GetWindow" (BYVAL hWnd AS DWORD, BYVAL wCmd AS DWORD) AS LONG
DECLARE FUNCTION GetWindowRect LIB "USER32.DLL" ALIAS "GetWindowRect" (BYVAL hWnd AS DWORD, lpRect AS RECT) AS LONG
DECLARE FUNCTION IsIconic LIB "USER32.DLL" ALIAS "IsIconic" (BYVAL hWnd AS DWORD) AS LONG
DECLARE FUNCTION LoadCursor LIB "USER32.DLL" ALIAS "LoadCursorA" (BYVAL hInstance AS DWORD, lpCursorName AS ASCIIZ) AS DWORD
DECLARE FUNCTION MoveWindow LIB "USER32.DLL" ALIAS "MoveWindow" (BYVAL hWnd AS DWORD, BYVAL x AS LONG, BYVAL y AS LONG, BYVAL nWidth AS LONG, BYVAL nHeight AS LONG, BYVAL bRepaint AS LONG) AS LONG
DECLARE FUNCTION PeekMessage LIB "USER32.DLL" ALIAS "PeekMessageA" (lpMsg AS tagMSG, BYVAL hWnd AS DWORD, BYVAL dwMsgFilterMin AS DWORD, BYVAL dwMsgFilterMax AS DWORD, BYVAL dwRemoveMsg AS DWORD) AS LONG
DECLARE FUNCTION RedrawWindow LIB "USER32.DLL" ALIAS "RedrawWindow" (BYVAL hWnd AS DWORD, lprcUpdate AS RECT, BYVAL hRgnUpdate AS DWORD, BYVAL fuRedraw AS LONG) AS LONG
DECLARE FUNCTION RegisterClassEx LIB "USER32.DLL" ALIAS "RegisterClassExA" (pcWndClassEx AS WNDCLASSEX) AS WORD
DECLARE FUNCTION ScreenToClient LIB "USER32.DLL" ALIAS "ScreenToClient" (BYVAL hWnd AS DWORD, lpPoint AS POINTAPI) AS LONG
DECLARE FUNCTION SendMessage LIB "USER32.DLL" ALIAS "SendMessageA" (BYVAL hWnd AS DWORD, BYVAL dwMsg AS DWORD, BYVAL wParam AS DWORD, BYVAL lParam AS LONG) AS LONG
DECLARE FUNCTION SetFocus LIB "USER32.DLL" ALIAS "SetFocus" (BYVAL hWnd AS DWORD) AS LONG
DECLARE FUNCTION SetForegroundWindow LIB "USER32.DLL" ALIAS "SetForegroundWindow" (BYVAL hWnd AS DWORD) AS LONG
DECLARE FUNCTION SetWindowPos LIB "USER32.DLL" ALIAS "SetWindowPos" (BYVAL hWnd AS DWORD, BYVAL hWndInsertAfter AS DWORD, BYVAL x AS LONG, BYVAL y AS LONG, BYVAL cx AS LONG, BYVAL cy AS LONG, BYVAL wFlags AS DWORD) AS LONG
DECLARE FUNCTION ShowWindow LIB "USER32.DLL" ALIAS "ShowWindow" (BYVAL hWnd AS DWORD, BYVAL nCmdShow AS LONG) AS LONG
DECLARE FUNCTION TranslateMessage LIB "USER32.DLL" ALIAS "TranslateMessage" (lpMsg AS tagMSG) AS LONG
DECLARE FUNCTION RegisterWindowMessage LIB "USER32.DLL" ALIAS "RegisterWindowMessageA" (lpString AS ASCIIZ) AS LONG
DECLARE FUNCTION ShellExecute LIB "SHELL32.DLL" ALIAS "ShellExecuteA" (BYVAL hwnd AS DWORD, lpOperation AS ASCIIZ, lpFile AS ASCIIZ, lpParameters AS ASCIIZ, lpDirectory AS ASCIIZ, BYVAL nShowCmd AS LONG) AS DWORD
DECLARE SUB      apiSleep LIB "KERNEL32.DLL" ALIAS "Sleep" (BYVAL dwMilliseconds AS DWORD)
DECLARE SUB      PostQuitMessage LIB "USER32.DLL" ALIAS "PostQuitMessage" (BYVAL nExitCode AS LONG)
DECLARE FUNCTION DestroyWindow LIB "USER32.DLL" ALIAS "DestroyWindow" (BYVAL hWnd AS DWORD) AS LONG
DECLARE FUNCTION PostMessage LIB "USER32.DLL" ALIAS "PostMessageA" (BYVAL hWnd AS DWORD, BYVAL dwMsg AS DWORD, BYVAL wParam AS DWORD, BYVAL lParam AS LONG) AS LONG
DECLARE FUNCTION GetFocus LIB "USER32.DLL" ALIAS "GetFocus" () AS DWORD
DECLARE FUNCTION SetWindowText LIB "USER32.DLL" ALIAS "SetWindowTextA" (BYVAL hWnd AS DWORD, lpString AS ASCIIZ) AS LONG

'////////////////////////////////////////

$MOVIEXT = ".avi.wmv.mpeg.mpg.mov.qt.mkv.mp4.flv."

%IDC_STATIC                 = -101
%IDC_MAIN_GDIMAGE           = 1001
%IDC_MAIN_SLIDEZOOM         = 1002
%IDC_MAIN_CHECKBOX          = 1003
%IDC_MAIN_CLOCK             = 1004
%IDC_MAIN_KNOBLEFT          = 1005
%IDC_MAIN_KNOBBIG           = 1006
%IDC_MAIN_KNOBRIGHT         = 1007
%IDC_MAIN_LOADIMAGE         = 1008
%IDC_MAIN_MOVIE             = 1009
%IDC_CB_MOVIE               = 1010
%IDC_MAIN_WALLPAPER         = 1012

'// GDImage constant to identify each sprite image.
%ID_PHOTO         = 1
%ID_LOGO          = 2

#INCLUDE "WINLIFT.INC"
#INCLUDE "GDIMAGE.INC"

%MyWindowWidth  = 800
%MyWindowHeight = 614

GLOBAL hImageCtrl, hMain AS DWORD, gnFocusID, gnTrueWidth, gnTrueHeight, gnUseWidth, gnUseHeight AS LONG, grWasZoom AS SINGLE
GLOBAL gsPluginPath, gsMoviePath, gsMovieToPlay AS STRING
GLOBAL WM_ZWPNOTIFICATION AS LONG

'// Main entry point
FUNCTION WINMAIN (BYVAL hInstance     AS LONG, _
                  BYVAL hPrevInstance AS LONG, _
                  BYVAL lpCmdLine     AS ASCIIZ PTR, _
                  BYVAL iCmdShow      AS LONG) AS LONG

    LOCAL wc AS WndClassEx
    LOCAL Msg AS tagMsg
    LOCAL hMutex, dwStyle, hCtrl AS DWORD
    LOCAL zClass AS ASCIIZ * 16, sResource AS STRING
    LOCAL K, x, y, w, h, NewW, NewH, IsInitialized AS LONG

    LOCAL zFullpathToFile AS ASCIIZ * %MAX_PATH
    LOCAL p AS POINTAPI, lpw AS RECT
    LOCAL imgW, imgH, xP, yP, xS, yS, hBitmap AS LONG

    zClass = "ZHUDPLUS"
'
    hMutex = CreateMutex(BYVAL 0&, 0, zClass)
    IF hMutex THEN
       IF GetLastError = %ERROR_ALREADY_EXISTS THEN
          DO
             hCtrl = FindWindow(zClass, ""): IF hCtrl THEN EXIT DO
             WHILE PeekMessage(Msg, 0, 0, 0, %PM_REMOVE): WEND
          LOOP
          IF IsIconic(hCtrl) THEN CALL ShowWindow(hCtrl, %SW_RESTORE)
          CALL SetForeGroundWindow(hCtrl)
          FUNCTION = 0
          EXIT FUNCTION
       END IF
    END IF

    wc.cbSize = SIZEOF(wc)
    IsInitialized = GetClassInfoEx(hInstance, zClass, wc)
    IF IsInitialized    = 0 THEN
       wc.cbSize        = SIZEOF(wc)
       wc.style         = %CS_HREDRAW OR %CS_VREDRAW
       wc.lpfnWndProc   = CODEPTR(WndProc)
       wc.cbClsExtra    = 0
       wc.cbWndExtra    = 0 '// %EXTEND_EXTRA * 4
       wc.hInstance     = hInstance
       wc.hIcon         = %NULL ' LoadIcon(wc.hInstance, "PROGRAM")
       wc.hCursor       = LoadCursor(%NULL, BYVAL %IDC_ARROW)
       wc.hbrBackground = %NULL
       wc.lpszMenuName  = %NULL
       wc.lpszClassName = VARPTR(zClass)
       wc.hIconSm       = wc.hIcon
       IF RegisterClassEx(wc) THEN IsInitialized = %TRUE
    END IF

    IF IsInitialized THEN
       x = Max&((GetSystemMetrics(%SM_CXSCREEN) - %MyWindowWidth) \ 2, 0)
       y = Max&((GetSystemMetrics(%SM_CYSCREEN) - %MyWindowHeight) \ 2, 0)
       w = %MyWindowWidth
       h = %MyWindowHeight
       dwStyle = %WS_POPUP OR %WS_THICKFRAME OR %WS_CAPTION OR %WS_SYSMENU OR %WS_MINIMIZEBOX OR %WS_MAXIMIZEBOX OR %WS_CLIPSIBLINGS OR %WS_CLIPCHILDREN ' OR %WS_VISIBLE

       hMain = CreateWindowEx(0, zClass, "HUD movie", dwStyle, _
                              x, -2000, w, h, 0, 0, hInstance, BYVAL 0&)

       IF hMain THEN

          WM_ZWPNOTIFICATION = RegisterWindowMessage("ZWPnotification")

          hImageCtrl = CreateWindowEx(0, $GDImageClassName, "", _
                                    %WS_CHILD Or %WS_VISIBLE, _
                                    78, 40, 628, 432, _
                                    hMain, %IDC_MAIN_GDIMAGE, _
                                    hInstance, _
                                    BYVAL 0&)

          hCtrl =    CreateWindowEx( 0, _
                                    "MSCTLS_TRACKBAR32", _
                                    "", _
                                    %WS_CHILD OR %WS_VISIBLE OR %WS_TABSTOP OR %TBS_VERT OR %TBS_BOTTOM OR %TBS_AUTOTICKS, _
                                    728, 40, 32, 432, _
                                    hMain, %IDC_MAIN_SLIDEZOOM, _
                                    hInstance, _
                                    BYVAL 0&)

          sResource = EXE.Path$ + "Resource\"
          gsMoviePath = EXE.Path$ + "Movie\" 
          gsPluginPath = EXE.Path$ + "BBPlugin\"


'         // START OF SKINNING SECTION --------------------------------------------
          IF skInitEngine("Naavi.sks", "") THEN

             CALL ShellExecute(0, "open", EXE.Path$ + "ZWM.exe", "", EXE.Path$, %SW_SHOWNOACTIVATE)
 
             CALL skSkinWindow(hMain, "Dock|Undock|Minimize|Maximize|Restore|Close")
 
'            // Anchor the SLIDEZOOM trackbar
             CALL skSetAnchorCtrl(hCtrl, %ANCHOR_HEIGHT_RIGHT)

             hCtrl =    CreateWindowEx( 0, _
                                       "COMBOBOX", _
                                       "", _
                                       %WS_CHILD OR %WS_VISIBLE OR %CBS_AUTOHSCROLL OR %CBS_DROPDOWNLIST OR %WS_VSCROLL OR %WS_TABSTOP OR %CBS_HASSTRINGS, _
                                       127, 542-24, 150, 164, _
                                       hMain, %IDC_CB_MOVIE, _
                                       zInstance(), _
                                       BYVAL 0&)
             CALL DetectMovie(hCtrl, 1)
             CALL skSkinChildCtrl(hCtrl, 0)
             CALL skSetAnchorCtrl(hCtrl, %ANCHOR_CENTER_HORZ_BOTTOM)

             hCtrl =    CreateWindowEx( 0, _
                                       "BUTTON", _
                                       "Transparent HUD mode", _
                                       %WS_CHILD OR %WS_VISIBLE OR %WS_TABSTOP OR %BS_AUTOCHECKBOX, _
                                       500, 542, 200, 16, _
                                       hMain, %IDC_MAIN_CHECKBOX, _
                                       zInstance(), _
                                       BYVAL 0&)
             CALL skSkinChildCtrl(hCtrl, 0): CALL skSetAnchorCtrl(hCtrl, %ANCHOR_CENTER_HORZ_BOTTOM)
             CALL ZI_UseWinLIFTbackground(hImageCtrl, %TRUE, %FALSE)

             hCtrl =    CreateWindowEx( 0, _
                                       "BUTTON", _
                                       "Dreamscene background", _
                                       %WS_CHILD OR %WS_VISIBLE OR %WS_TABSTOP OR %BS_AUTOCHECKBOX, _
                                       127, 542, 150, 16, _
                                       hMain, %IDC_MAIN_MOVIE, _
                                       zInstance(), _
                                       BYVAL 0&)
             CALL skSkinChildCtrl(hCtrl, 0): CALL skSetAnchorCtrl(hCtrl, %ANCHOR_CENTER_HORZ_BOTTOM)
             CALL skCreateTooltip(hCtrl, "Enable/disable movie mode")


'            // 4.73 WinLIFT clock
             hCtrl = skClockCtrl(hMain, sResource + "Clock_09_92.png", 4, 476, 0, 0, %IDC_MAIN_CLOCK, &H7FCB0000, &H7F8F8F8F, 0)
             CALL skSetAnchorCtrl(hCtrl, %ANCHOR_BOTTOM)
             CALL skCreateToolTip(hCtrl, "WinLIFT clock widget")

             hCtrl = skButtonImage(hMain, sResource + "SelectImage.png", 780 - 58, 498, %IDC_MAIN_LOADIMAGE, 5)
             CALL skSetAnchorCtrl(hCtrl, %ANCHOR_BOTTOM_RIGHT)
             CALL skCreateToolTip(hCtrl, "WinLIFT ButtonImage")

             hCtrl = skKnobGauge(hMain, sResource + "BTN_Gauge01.png", 303, 527, 0, 0, %IDC_MAIN_KNOBLEFT, 0, 0, 0, 0)
             CALL skSetAnchorCtrl(hCtrl, %ANCHOR_CENTER_HORZ_BOTTOM)
             CALL skCreateToolTip(hCtrl, "WinLIFT KnobGauge")
             hCtrl = skKnobGauge(hMain, sResource + "BTN_Gauge02.png", 344, 476, 0, 0, %IDC_MAIN_KNOBBIG, 0, 0, 0, 0)
             CALL skSetAnchorCtrl(hCtrl, %ANCHOR_CENTER_HORZ_BOTTOM)
             CALL skCreateToolTip(hCtrl, "WinLIFT KnobGauge")
             hCtrl = skKnobGauge(hMain, sResource + "BTN_Gauge01.png", 436, 527, 0, 0, %IDC_MAIN_KNOBRIGHT, 0, 0, 0, 0)
             CALL skSetAnchorCtrl(hCtrl, %ANCHOR_CENTER_HORZ_BOTTOM)
             CALL skCreateToolTip(hCtrl, "WinLIFT KnobGauge")

             IF hImageCtrl THEN

'               // Add a skinned border around the GDImage control.
                CALL GetWindowRect(hImageCtrl, lpw)
                p.X = lpw.nLeft: p.Y = lpw.nTop
                CALL ScreenToClient(hMain, p)
                CALL skBorder(hImageCtrl, p.X - 1, p.Y - 1, lpw.nRight - lpw.nLeft + 2, lpw.nBottom - lpw.nTop + 2, 0, 1)
'               // Anchor the GDImage control.
                CALL skSetAnchorCtrl(hImageCtrl, %ANCHOR_HEIGHT_WIDTH)

'               // Compute the good range to use with the zoom slider
                CALL ZI_GetImageSizeFromControl(hImageCtrl, imgW, imgH)
                CALL ZI_Iconise(imgW, imgH, lpw.nRight - lpw.nLeft, lpw.nBottom - lpw.nTop, xP, yP, xS, yS)
                IF imgW THEN
                   hCtrl = GetDlgItem(hMain, %IDC_MAIN_SLIDEZOOM)
                   CALL SendMessage(hCtrl, %TBM_SETPAGESIZE, 0, 1)
                   CALL SendMessage(hCtrl, %TBM_SETLINESIZE, 0, 1)
                   CALL SendMessage(hCtrl, %TBM_SETTICFREQ, 0, 1)
                   CALL SendMessage(hCtrl, %TBM_SETRANGE, 1, MAK(LONG, 1, imgW))
                   CALL SendMessage(hCtrl, %TBM_SETPOS, 1, xS)
                END IF

'               // Start with the default picture.
                zFullpathToFile = sResource + "Naavi.png"
                CALL UseThisPhoto(zFullpathToFile, 0)

'               // Add a transparent logo on the top right corner.
                zFullpathToFile = sResource + "GDImage.png"
'               // Load image and retrieve the width and height of its bitmap.
                hBitmap = ZI_CreateBitmapFromFile(zFullpathToFile, imgW, imgH)
'               // Use the new hBitmap to create a sprite image on the top right corner.
                CALL ZD_DrawBitmapToCtrl(hImageCtrl, (lpw.nRight - lpw.nLeft) - (imgW + 10), 10, hBitmap, ZD_ColorARGB(255, 0), %ID_LOGO, %ZS_VISIBLE)
'               // Anchor the logo to the top right corner.
                CALL ZD_SetObjectAnchorMode(%ID_LOGO, %ANCHOR_RIGHT)
'               // Lock and disable the sprite image.
                CALL ZD_SetObjectLocked(%ID_LOGO, %TRUE)

             END IF

             CALL ShowWindow(hMain, %SW_SHOW)

'            // Create a fall down effect animation.
             CALL GetWindowRect(hMain, lpw)
             NewW = lpw.nRight - lpw.nLeft
             NewH = lpw.nBottom - lpw.nTop
             x = Max((GetSystemMetrics(%SM_CXSCREEN) - %MyWindowWidth) \ 2, 0)
             y = Max((GetSystemMetrics(%SM_CYSCREEN) - %MyWindowHeight) \ 2, 0)
             w = %MyWindowWidth
             h = %MyWindowHeight
             CALL ShowWindow(hImageCtrl, 0)
             dwStyle = %RDW_INVALIDATE OR %RDW_INTERNALPAINT OR %RDW_ERASE OR %RDW_ERASENOW OR %RDW_UPDATENOW OR %RDW_ALLCHILDREN OR %RDW_FRAME
             FOR k = -h TO -1 STEP 8
                 CALL MoveWindow(hMain, x, k, w, h, 0)'1)
'                 CALL RedrawWindow(hMain, BYVAL 0&, BYVAL 0&, dwStyle)
                 CALL ZI_UpdateWindow(hMain, 1)'0)
             NEXT
             FOR k = 0 TO y step 8
                 CALL MoveWindow(hMain, x, k, w, h, 0)
                 CALL RedrawWindow(hMain, BYVAL 0&, BYVAL 0&, dwStyle)
                 'CALL ZI_UpdateWindow(hMain, 0)
             NEXT
             CALL ShowWindow(hMain, %SW_HIDE)
             x = Max&((GetSystemMetrics(%SM_CXSCREEN) - NewW) \ 2, 0)
             y = Max&((GetSystemMetrics(%SM_CYSCREEN) - NewH) \ 2, 0)
             CALL MoveWindow(hMain, x, y, NewW, NewH, 0)
             CALL ShowWindow(hMain, %SW_SHOW)
             CALL ShowWindow(hImageCtrl, %SW_SHOW)


'            // Main message pump.
             WHILE GetMessage(Msg, 0, 0, 0)
                CALL TranslateMessage(Msg)
                CALL DispatchMessage(Msg)
             WEND


          END IF

       END IF
    END IF

    IF hMutex THEN CALL CloseHandle(hMutex)

END FUNCTION

SUB GDImageSetZoomRange(BYVAL bmW AS LONG, BYVAL bmH AS LONG, xSize AS LONG, ySize AS LONG)
    LOCAL lpr AS RECT, xPos, yPos, hCtrl AS LONG
    CALL GetClientRect(hImageCtrl, lpr)
    CALL ZI_Iconise(bmW, bmH, lpr.nRight, lpr.nBottom, xPos, yPos, xSize, ySize)

    hCtrl = GetDlgItem(hMain, %IDC_MAIN_SLIDEZOOM)
    CALL SendMessage(hCtrl, %TBM_SETRANGE, 1, MAK(LONG, CLNG((xSize / bmW) * 128), 1500))
END SUB

'SUB UpdateQualityStatus(BYVAL bQuality AS LONG)
'    LOCAL nInterpolation AS LONG
'    IF bQuality THEN
'       nInterpolation = 2 ' %InterpolationModeHighQuality
'    ELSE
'       nInterpolation = 0 ' %InterpolationModeDefault
'    END IF
'    IF ZD_GetObjectQuality(%ID_PHOTO) <> nInterpolation THEN
'       CALL ZD_SetObjectQuality(%ID_PHOTO, nInterpolation, %TRUE)
'    END IF
'END SUB

SUB UseThisPhoto(BYVAL sUsePhoto AS STRING, BYVAL bReset AS LONG)
    LOCAL lpr AS RECT, rZoomValue AS SINGLE
    LOCAL nHbitmap, nW, nH, nX, nY, nSizeX, nSizeY, nPosAngle AS LONG, rAspect AS SINGLE

    '// Make sure to disable the crop rectangle if any
    IF ZI_GetToolCropStatus(hImageCtrl) THEN ZI_DisableCropRectangle(hImageCtrl)

    CALL ZI_GetImageSizeFromFile((sUsePhoto), gnTrueWidth, gnTrueHeight)
    nW = MAX&(gnTrueWidth, gnTrueHeight): IF nW > 1024 THEN nW = 1024
    nHbitmap = ZI_FitBitmapFromFile((sUsePhoto), nW, nW)

    CALL ZI_GetBitmapSize(nHbitmap, nW, nH)

    IF nHbitmap THEN
       gnUseWidth = nW: gnUseHeight = nH
'
       CALL zSplitN(sUsePhoto, "", sUsePhoto): sUsePhoto = UCASE$(LEFT$(sUsePhoto, 1)) + LCASE$(MID$(sUsePhoto, 2))
'
       '// Compute range based on the image size
       CALL GDImageSetZoomRange(gnUseWidth, gnUseHeight, nSizeX, nSizeY)
'
       CALL GetClientRect(hImageCtrl, lpr)
       CALL ZI_Iconise(gnTrueWidth, gnTrueHeight, lpr.nRight, lpr.nBottom, nX, nY, nW, nH)
       IF nW > nH THEN
          rAspect = nW / nH
       ELSE
          rAspect = 1
       END IF

       rZoomValue = (nSizeX / (gnUseWidth / rAspect))
       CALL SendMessage(GetDlgItem(hMain, %IDC_MAIN_SLIDEZOOM), %TBM_SETPOS, 1, CLNG(rZoomValue * 1000))

       CALL GetClientRect(hImageCtrl, lpr)
       nX = (lpr.nRight - gnUseWidth) / 2
       nY = (lpr.nBottom - gnUseHeight) / 2

       CALL ZD_DrawBitmapToCtrl(hImageCtrl, nX, nY, nHbitmap, ZD_ColorARGB(255, 0), %ID_PHOTO, %ZS_HIDDEN) '// %ZS_VISIBLE)
       CALL ZD_SetObjectScale(%ID_PHOTO, rZoomValue)

       nPosAngle = skGaugeGetPos(GetDlgItem(hMain, %IDC_MAIN_KNOBBIG))
       CALL ZD_SetObjectAngle(%ID_PHOTO, nPosAngle, %FALSE)
       CALL ZD_SetObjectAnchorMode(%ID_PHOTO, %ANCHOR_CENTER)

       'CALL UpdateQualityStatus(%TRUE)

       CALL SetFocus(hImageCtrl)
       CALL ZI_SetObjectFocusID(%ID_PHOTO)
       gnFocusID = %ID_PHOTO

       CALL ZD_SetObjectVisibility(%ID_PHOTO, %ZS_VISIBLE)
       CALL ZI_UpdateWindow(hImageCtrl, 0)
    END IF
END SUB

'// Main window procedure
FUNCTION WndProc(BYVAL hWnd AS LONG, BYVAL Msg AS LONG, BYVAL wParam AS LONG, BYVAL lParam AS LONG) EXPORT AS LONG

    LOCAL hCtrl, hDW AS DWORD, ZoomValue, OldZoomValue AS SINGLE, nPos, imgW, imgH, xP, yP, xS, yS, hPopup AS LONG
    LOCAL rc AS RECT, sDataString AS STRING, szText AS ASCIIZ * %MAX_PATH
    LOCAL ptNMHDR AS NMHDR PTR

'zTrace("&H"+HEX$(Msg))

    SELECT CASE LONG Msg

    CASE WM_ZWPNOTIFICATION
         SELECT CASE LONG wParam
         CASE %NM_MOVIEPLAYING

              CALL ShowWindow(ZWM_Handle(), %SW_SHOW)
              CALL SetForeGroundWindow(hWnd)

         END SELECT

    CASE %WM_NOTIFY
         ptNMHDR = lParam
'        // Assign the new rotation angle to the sprite image.
         nPos = @ptNMHDR.code
         SELECT CASE LONG @ptNMHDR.idfrom
         CASE %IDC_MAIN_KNOBBIG
            CALL ZD_SetObjectAngle(gnFocusID, nPos, %TRUE)
            CALL skGaugeSetPos(GetDlgItem(hWnd, %IDC_MAIN_KNOBLEFT), nPos, %TRUE)
            CALL skGaugeSetPos(GetDlgItem(hWnd, %IDC_MAIN_KNOBRIGHT), nPos, %TRUE)
         CASE %IDC_MAIN_KNOBLEFT
            CALL ZD_SetObjectAngle(gnFocusID, nPos, %TRUE)
            CALL skGaugeSetPos(GetDlgItem(hWnd, %IDC_MAIN_KNOBBIG), nPos, %TRUE)
            CALL skGaugeSetPos(GetDlgItem(hWnd, %IDC_MAIN_KNOBRIGHT), nPos, %TRUE)
         CASE %IDC_MAIN_KNOBRIGHT
            CALL ZD_SetObjectAngle(gnFocusID, nPos, %TRUE)
            CALL skGaugeSetPos(GetDlgItem(hWnd, %IDC_MAIN_KNOBBIG), nPos, %TRUE)
            CALL skGaugeSetPos(GetDlgItem(hWnd, %IDC_MAIN_KNOBLEFT), nPos, %TRUE)
         END SELECT

    CASE %WM_SIZE, %WM_MOVE, %WM_WINDOWPOSCHANGED, %WM_IME_NOTIFY
         IF ZWM_Handle() THEN
            ZWM_SizeMove()
         END IF
    
    CASE %WM_COMMAND

         SELECT CASE LONG LO(INTEGER, wParam)

         CASE %IDC_MAIN_LOADIMAGE
              hDW = skCreateDW(hWnd)
              sDataString = ZI_LoadDialog(hWnd)
              CALL skDestroyDW(hDW)

              IF LEN(sDataString) THEN
                 CALL UseThisPhoto(sDataString, 0)
              END IF

         CASE %IDC_MAIN_CHECKBOX
              IF SendMessage(GetDlgItem(hWnd, %IDC_MAIN_CHECKBOX), %BM_GETCHECK, 0, 0) = %BST_CHECKED THEN
                 CALL ZI_UseWinLIFTbackground(hImageCtrl, %FALSE, %TRUE)
              ELSE
                 CALL ZI_UseWinLIFTbackground(hImageCtrl, %TRUE, %TRUE)
              END IF
              CALL SetFocus(hImageCtrl)

         CASE %IDC_MAIN_MOVIE
              IF SendMessage(GetDlgItem(hWnd, %IDC_MAIN_MOVIE), %BM_GETCHECK, 0, 0) = %BST_CHECKED THEN
                 hCtrl = GetDlgItem(hWnd, %IDC_CB_MOVIE)
                 CALL SendMessage(hCtrl, %CB_GETLBTEXT, SendMessage(hCtrl, %CB_GETCURSEL, 0, 0), VARPTR(szText))
                 gsMovieToPlay = gsMoviePath + szText
                 hPopup = skGetDWMregion(hWnd): IF hPopup THEN ShowWindow(hPopup, %SW_HIDE)
                 ZWM_Show()
              ELSE
                 hPopup = skGetDWMregion(hWnd): IF hPopup THEN ShowWindow(hPopup, %SW_SHOW)
                 ZWM_Hide()
              END IF
              CALL SetFocus(hImageCtrl)

         CASE %IDC_CB_MOVIE
              IF HI(INTEGER, wParam) = %CBN_SELENDOK THEN
                 hCtrl = GetDlgItem(hWnd, %IDC_CB_MOVIE)
                 CALL SendMessage(hCtrl, %CB_GETLBTEXT, SendMessage(hCtrl, %CB_GETCURSEL, 0, 0), VARPTR(szText))
                 gsMovieToPlay = gsMoviePath + szText
                 IF SendMessage(GetDlgItem(hWnd, %IDC_MAIN_MOVIE), %BM_GETCHECK, 0, 0) = %BST_CHECKED THEN
                    CALL ZWM_Show()
                 END IF
                 CALL SetFocus(hImageCtrl)
              END IF

         END SELECT

    CASE %WM_VSCROLL
         IF GetDlgCtrlId(lParam) = %IDC_MAIN_SLIDEZOOM THEN
            CALL UseThisZoom(SendMessage(lParam, %TBM_GetPos, 0, 0)) '// Do not use nPosition, because it could be NULL.
         END IF

    CASE %WM_CLOSE
         hPopup = skGetDWMregion(hWnd)
'        // Hide DWMregion if any
         IF hPopup THEN MoveWindow(hPopup, 0, 0, 0, 0, 1)

    CASE %WM_DESTROY
         ZWM_Destroy()
         CALL PostQuitMessage(0)
         FUNCTION = 0: EXIT FUNCTION

    END SELECT

    FUNCTION = DefWindowProc(hWnd, Msg, wParam, lParam)

END FUNCTION

SUB UseThisZoom(BYVAL nPos AS LONG)
    IF gnFocusID THEN
       LOCAL nCtrl AS LONG, rZoomValue AS SINGLE

       rZoomValue = nPos / 1000
       IF rZoomValue <> grWasZoom THEN
          nCtrl = ZD_GetObjectParent(gnFocusID)
          '// Make sure to disable the crop rectangle if any
          IF ZI_GetToolCropStatus(nCtrl) THEN ZI_DisableCropRectangle(nCtrl)

          CALL ZD_SetObjectScale(gnFocusID, rZoomValue)
          CALL ZI_UpdateWindow(nCtrl, %FALSE)

       END IF
       grWasZoom = rZoomValue
    END IF
END SUB

SUB SetStaticValue(BYVAL sUseString AS STRING, BYVAL nValue AS LONG)
    LOCAL nIndex, nStaticHandle AS LONG
    sUseString += "|"
    nStaticHandle = GetDlgItem(hMain, %IDC_STATIC)
    IF nStaticHandle = 0 THEN
      nStaticHandle = CreateWindowEx(0, "LISTBOX", "", %WS_CHILD OR %LBS_HASSTRINGS, 0, 0, 0, 0, hMain, %IDC_STATIC, zInstance(), BYVAL %NULL)
    END IF
    IF nStaticHandle THEN
       nIndex = SendMessage(nStaticHandle, 399, -1, BYVAL STRPTR(sUseString))
       IF nIndex > -1 THEN '// We found same static
          CALL SendMessage(nStaticHandle, 410, nIndex, nValue)
       ELSE '// Add it to our static list
          CALL SendMessage(nStaticHandle, 410, SendMessage(nStaticHandle, 384, 0, BYVAL STRPTR(sUseString)), nValue)
       END IF
    END IF
END SUB

FUNCTION GetStaticValue(BYVAL sUseString AS STRING) AS LONG
    LOCAL nIndex, nValue, nStaticHandle AS LONG
    sUseString += "|"
    nValue = 0
    nStaticHandle = GetDlgItem(hMain, %IDC_STATIC)
    IF nStaticHandle THEN
       nIndex = SendMessage(nStaticHandle, 399, -1, BYVAL STRPTR(sUseString))
       IF nIndex > -1 THEN '// We found it
          nValue = SendMessage(nStaticHandle, 409, nIndex, 0)
       END IF
    END IF
    FUNCTION = nValue
END FUNCTION

SUB ZWM_Destroy()
    ZWM_Message("DESTROY")
END SUB

FUNCTION ZWM_Handle() AS LONG
    LOCAL nRet AS LONG, zClass AS ASCIIZ * 16
    nRet = GetStaticValue("WPHANDLE")
    IF nRet = 0 THEN
       zClass = "ZWMOVIE"
       nRet = FindWindow(zClass, zClass)
       IF nRet THEN
          SetStaticValue("WPHANDLE", nRet)
          ZWM_SizeMove()
          ZWM_Message("PARENT," + STR$(hMain) + "," + STR$(%IDC_MAIN_WALLPAPER))
       END IF
    END IF
    FUNCTION = nRet
END FUNCTION

FUNCTION ZWM_Message(BYVAL sMsg AS STRING) AS LONG
    LOCAL szText AS ASCIIZ * 512
    szText = sMsg
    FUNCTION = SendMessage(ZWM_Handle(), %WM_SETTEXT, 0, BYVAL VARPTR(szText))
END FUNCTION

SUB ZWM_Play()
    ZWM_Message("PLAY," + gsMovieToPlay)
END SUB

SUB ZWM_SizeMove()
    LOCAL lpw AS RECT
    LOCAL x, y, w, h, hWnd, hPopup AS LONG
    CALL GetWindowRect(hMain, lpw)
    x = lpw.nLeft + skGetSystemMetrics(%SK_DWM_LEFT)
    y = lpw.nTop + skGetSystemMetrics(%SK_DWM_TOP)
    w = lpw.nRight - skGetSystemMetrics(%SK_DWM_RIGHT) - x
    h = lpw.nBottom - skGetSystemMetrics(%SK_DWM_BOTTOM) - y

'   // Use this to move the window in case of AERO shake
'   // because setting the new location with SetWindowPos
'   // may fail!
    hWnd = ZWM_Handle() 
    hPopup = skGetDWMregion(hMain): IF hPopup = 0 THEN hPopup = hMain
    CALL SetWindowPos(hWnd, GetWindow(hPopup, 2), 0, 0, 0, 0, %SWP_NOMOVE OR %SWP_NOSIZE OR %SWP_NOOWNERZORDER OR %SWP_NOACTIVATE)
    CALL MoveWindow(hWnd, x, y, w, h, 0)
END SUB

SUB ZWM_Stop()
    ZWM_Message("STOP")
END SUB

SUB ZWM_Show()
    LOCAL lpw AS RECT
    LOCAL x, y, w, h, hWnd, hPopup AS LONG
    CALL GetWindowRect(hMain, lpw)
    x = lpw.nLeft + skGetSystemMetrics(%SK_DWM_LEFT)
    y = -2000
    w = lpw.nRight - skGetSystemMetrics(%SK_DWM_RIGHT) - x
    h = lpw.nBottom - skGetSystemMetrics(%SK_DWM_BOTTOM) - y

'   // Use this to move the window in case of AERO shake
'   // because setting the new location with SetWindowPos
'   // may fail!
    hWnd = ZWM_Handle() 
    hPopup = skGetDWMregion(hMain): IF hPopup = 0 THEN hPopup = hMain
    CALL SetWindowPos(hWnd, GetWindow(hPopup, 2), 0, 0, 0, 0, %SWP_NOMOVE OR %SWP_NOSIZE OR %SWP_NOOWNERZORDER OR %SWP_NOACTIVATE)
    CALL MoveWindow(hWnd, x, y, w, h, 0)
'    CALL ShowWindow(hWnd, %SW_SHOW)
    ZWM_SizeMove()
    ZWM_Play()
    'CALL ShowWindow(hWnd, %SW_SHOW)
END SUB

SUB ZWM_Hide()
    CALL ShowWindow(ZWM_Handle(), %SW_HIDE)
    ZWM_Stop()
END SUB

TYPE FILETIME
    dwLowDateTime AS DWORD
    dwHighDateTime AS DWORD
END TYPE

TYPE WIN32_FIND_DATA
    dwFileAttributes AS DWORD
    ftCreationTime AS FILETIME
    ftLastAccessTime AS FILETIME
    ftLastWriteTime AS FILETIME
    nFileSizeHigh AS DWORD
    nFileSizeLow AS DWORD
    dwReserved0 AS DWORD
    dwReserved1 AS DWORD
    cFileName AS ASCIIZ * %MAX_PATH
    cAlternateFileName AS ASCIIZ * 14
END TYPE

DECLARE FUNCTION FindClose LIB "KERNEL32.DLL" ALIAS "FindClose" (BYVAL hFindFile AS DWORD) AS LONG
DECLARE FUNCTION FindFirstFile LIB "KERNEL32.DLL" ALIAS "FindFirstFileA" (lpFileName AS ASCIIZ, lpFindFileData AS WIN32_FIND_DATA) AS DWORD
DECLARE FUNCTION FindNextFile LIB "KERNEL32.DLL" ALIAS "FindNextFileA" (BYVAL hFindFile AS DWORD, lpFindFileData AS WIN32_FIND_DATA) AS LONG
DECLARE FUNCTION CharLower LIB "USER32.DLL" ALIAS "CharLowerA" (lpsz AS ASCIIZ) AS DWORD

SUB ComboSelectPlus(BYVAL hCombo AS LONG, BYVAL nSelected AS LONG)
    IF nSelected > 0 THEN DECR nSelected '// Because ListBox is zero based
    IF hCombo THEN CALL SendMessage(hCombo, %CB_SETCURSEL, nSelected, 0)
END SUB

SUB DetectMovie(BYVAL hCombo AS LONG, BYVAL nUseItem AS LONG)

    IF hCombo = 0 THEN EXIT SUB

    LOCAL nCount, WashFind, hFind AS LONG
    LOCAL fd AS WIN32_FIND_DATA
    LOCAL zTmp AS ASCIIZ * %MAX_PATH
    LOCAL zExt AS ASCIIZ * 8

    CALL SendMessage(hCombo, %CB_RESETCONTENT, 0, 0)

    WashFind = FindFirstFile(gsMoviePath + "*.*", fd)
    hFind = WashFind
    nCount = 0
    DO WHILE hFind > 0
       IF ASC(fd.cFileName) <> 46 THEN
          IF INSTR(CHR$(0,1,32,33,128), CHR$(fd.dwFileAttributes)) THEN
             zTmp = fd.cFileName
             zExt = PATHNAME$(EXTN, fd.cFileName) + ".": CALL CharLower(zExt)
             IF INSTR($MOVIEXT, zExt) THEN
                IF SendMessage(hCombo, %CB_ADDSTRING, 0, VARPTR(zTmp)) > -1 THEN
                   nCount += 1
                END IF
             END IF
          END IF
       END IF
       hFind = FindNextFile(WashFind, fd)
    LOOP
    CALL FindClose(WashFind)

    IF nCount THEN
       IF nUseItem > nCount THEN nUseItem = 1
       CALL ComboSelectPlus(hCombo, nUseItem)
    END IF

END SUB
